	/*--------------------------------------------------------------*/
	/*								*/
	/* Give MD Name - for Sony MDS-S39 MiniDisc Deck 		*/
	/* for use with EZ-LINK or equivalent Infrared Transmitter	*/
	/* By Robin Don, August 1999					*/
	/*								*/
	/* Use supplied Codesets/Sony_MDS-S39 with InfraRexxDaemon	*/
	/*								*/
	/*--------------------------------------------------------------*/
		VERSION = "$VER: GiveMDTrackName-Sony_MDS_S39 v0.1"
	/*--------------------------------------------------------------*/

/* SIMPLE - Names an MD */

IF ARG() ~= 1 THEN DO
	SAY 'USAGE: rx GiveMDName <"NAME">'
	EXIT 5
	END
	

TRACK_NAME = ARG(1)

SAY 'Naming Disc__ : ' TRACK_NAME
SAY ''

/* Don't worry about the rest */
/*------------------------------------------------------------------------------*/
EZLINK = "INFRAREXX"

/* Internal timings 			*/
/* Values specific to SONY MDS-S39	*/
/*------------------------------------------------------------------------------*/
DELAY.letters	= 300
DELAY.stop	= 1000
DELAY.pause	= 1000
DELAY.name	= 25000
DELAY.clear	= 200
DELAY.char	= 7500

/* Go */
/*------------------------------------------------------------------------------*/
ADDRESS VALUE EZLINK

/* Set player ready to accept name */
'MD_STOP'
SAY '- Stopping'
my_wait( DELAY.stop, 1)

'MD_NAME'
SAY '- Entering Name'
my_wait( delay.name, 1)

/* Erase Loop */
/*------------------------------------------------------------------------------*/
SAY ' -> Erasing any existing name'
DO i=1 to 50
	'MD_CLEAR'
	my_wait( DELAY.clear, 1 )
END
my_wait( DELAY.clear, 1 )


/* Name Loop */
/*------------------------------------------------------------------------------*/
SAY ' -> Entering new name'
case = upper	/* Player always starts in UPPER CASE from remote control */
newcase = upper

numbers = false	
newnumbers = false

SAY '- Entering Name...'
DO i=1 to LENGTH( TRACK_NAME )

	ch = SUBSTR( track_name,i,1)
	WRITECH( stdout,  ch )
	
	IF C2D( ch ) >= C2D( '0' ) & C2D( ch ) <= C2D( '9' ) THEN newnumbers = true
	ELSE 	newnumbers = false
	
	IF C2D( ch ) >= C2D( 'a' ) & C2D( ch ) <= C2D( 'z' ) THEN newcase = lower
	IF C2D( ch ) >= C2D( 'A' ) & C2D( ch ) <= C2D( 'Z' ) THEN newcase = upper
	
	IF newcase ~= case THEN DO
		'MD_CHAR'
		my_wait( DELAY.char, 1 )
		case = newcase
		END
		
	IF newnumbers ~= numbers THEN DO
		'MD_NUM'
		my_wait( DELAY.char, 1 )
		numbers = newnumbers
		END

		
	'MD_'||SUBSTR( TRACK_NAME,i,1)
	
	my_wait( DELAY.letters, 1 )	
	
END
my_wait( DELAY.letters, 1 )	


'MD_NAME'
my_wait( DELAY.letters, 1 )
'MD_STOP'
SAY ''
SAY ' DONE.'

EXIT

/* a VERY BAD wait function - eats cycles */
/*------------------------------------------------------------------------------*/
my_wait:
	ARG delay, times
	DO iiiii=0 to (delay*times)
	END
	RETURN 0
/*------------------------------------------------------------------------------*/
/*------------------------------------------------------------------------------*/
/*------------------------------------------------------------------------------*/


